<?php

use Zen\Payment\Paywall;
use Zen\Payment\Util;

include_once(Mage::getConfig()->getModuleDir('helper', 'Zen') . '/payment-core/src/Util.php');
include_once(Mage::getConfig()->getModuleDir('helper', 'Zen') . '/payment-core/src/Paywall.php');

/**
 * Class Zen_Block_Redirect
 */
class Zen_Block_Redirect extends Mage_Core_Block_Template
{

	/**
	 * @var Zen_Model_PaymentMethod | null
	 */
	private $methodInstance = null;

	/**
	 * @return string
	 * @throws Mage_Core_Exception
	 * @throws Mage_Core_Model_Store_Exception
	 * @throws Varien_Exception
	 */
	public function createForm()
	{

		$order = $this->getOrderData();

		$payment = new Paywall(
			Util::ENVIRONMENT_PRODUCTION,
			Mage::getStoreConfig('payment/zen/paywall_secret'),
			Mage::getStoreConfig('payment/zen/terminal_uuid')
        );

		return $payment->buildOrderForm($order, Mage::helper('zen')->__('Continue'));
	}

	/**
	 * @return array
	 * @throws Mage_Core_Exception
	 * @throws Varien_Exception
	 */
	public function getOrderData()
	{
		return $this->getMethodInstance()->getRedirectionFormData();
	}

	/**
	 * @return Zen_Model_PaymentMethod
	 * @throws Mage_Core_Exception
	 */
	public function getMethodInstance()
	{
		if($this->methodInstance === null) {
			$this->methodInstance = $this->_getOrder()->getPayment()->getMethodInstance();
		}

		return $this->methodInstance;
	}

	/**
	 * @return string
	 * @throws Mage_Core_Exception
	 * @throws Varien_Exception
	 */
	public function getOrderId()
	{
		return $this->getMethodInstance()->getOrderId();
	}

	/**
	 * @return Mage_Sales_Model_Order | null
	 */
	protected function _getOrder()
	{
		$getOrder = $this->getOrder();
		if($getOrder) {
			return $getOrder;
		}
		if($orderIncrementId = Mage::getSingleton('checkout/session')->getLastRealOrderId()) {
			return Mage::getModel('sales/order')->loadByIncrementId($orderIncrementId);
		}

		return null;
	}
}
