<?php

/**
 * Class Zen_ProcessingController
 */
class Zen_ProcessingController extends Mage_Core_Controller_Front_Action
{
	/**
	 *
	 */
	public function redirectAction()
	{

		$zenBlockRedirect = new Zen_Block_Redirect();

		$orderId = $zenBlockRedirect->getOrderId();
		$bodyCommentSentOrder = $this->getTextComment();

		if(empty($orderId)
			|| !$this->validateComment($bodyCommentSentOrder)) {

			Mage::app()->getFrontController()->getResponse()->setRedirect(Mage::getBaseUrl());

			return;
		}

		$checkout = $this->_getCheckout();

		$order = Mage::getModel('sales/order')->loadByIncrementId($orderId);

		if (!$order->getEmailSent()) {
			$order->sendNewOrderEmail();
			$order->setEmailSent(true);
		}

		$order->addStatusHistoryComment($bodyCommentSentOrder);
		$order->save();

		$html = $this->getLayout()->createBlock('zen/redirect')
			->setTemplate('zen/redirect.phtml')->renderView();
		$this->getResponse()->setBody($html);

		Mage::getSingleton('checkout/cart')->truncate();
		Mage::getSingleton('checkout/cart')->save();
		$checkout->setPaymentpageQuoteId($checkout->getQuoteId());
		$checkout->unsQuoteId();
		$checkout->unsRedirectUrl();
	}

	/**
	 * @return string
	 */
	private function getTextComment()
	{
		return Mage::helper('zen')->__('Order was sent to Zen paywall.');
	}

	/**
	 * @param string $comment
	 *
	 * @return bool
	 * @throws Mage_Core_Exception
	 * @throws Varien_Exception
	 */
	private function validateComment($comment)
	{

		$zenBlockRedirect = new Zen_Block_Redirect();
		$orderId = $zenBlockRedirect->getOrderId();
		$order = Mage::getModel('sales/order')->loadByIncrementId($orderId);

		return $order->getStatusHistoryCollection()->getFirstItem()->getComment() !== $comment;
	}

	/**
	 * @return Mage_Checkout_Model_Session
	 */
	private function _getCheckout()
	{
		return Mage::getSingleton('checkout/session');
	}

	/**
	 *
	 */
	public function successAction()
	{
		$checkout = $this->_getCheckout();
		$checkout->setQuoteId($checkout->getPaymentpageQuoteId(true));
		$checkout->getQuote()->setIsActive(false)->save();
		$this->_redirect('checkout/onepage/success');
	}

	/**
	 *
	 */
	public function failureAction()
	{
		$checkout = $this->_getCheckout();
		$checkout->setQuoteId($checkout->getPaymentpageQuoteId(true));
		$checkout->getQuote()->setIsActive(false)->save();
		$this->_redirect('checkout/onepage/failure');
	}

	/**
	 *
	 */
	public function cancelAction()
	{
		$checkout = $this->_getCheckout();
		$checkout->setQuoteId($checkout->getPaymentpageQuoteId(true));
		$checkout->addError(Mage::helper('zen')->__('The order has been canceled.'));
		$this->_redirect('checkout/cart');
	}
}
